# The name of your app.
# NOTICE: name defined in TARGET has a corresponding QML filename.
#         If name defined in TARGET is changed, following needs to be
#         done to match new name:
#         - corresponding QML filename must be changed
#         - desktop icon filename must be changed
#         - desktop filename must be changed
#         - icon definition filename in desktop file must be changed
TARGET = harbour-metacrane

CONFIG += sailfishapp
CONFIG += c++11

SOURCES += src/harbour-metacrane.cpp \
    3rdparty/QtWebsocket/QWsSocket.cpp \
    3rdparty/QtWebsocket/QWsServer.cpp \
    3rdparty/QtWebsocket/QWsHandshake.cpp \
    3rdparty/QtWebsocket/QWsFrame.cpp \
    3rdparty/QtWebsocket/QTlsServer.cpp \
    3rdparty/QtWebsocket/functions.cpp \
    src/metacraneclient.cpp \
    src/metacranesocket.cpp \
    src/filesearch.cpp

OTHER_FILES += qml/harbour-metacrane.qml \
    qml/cover/CoverPage.qml \
    qml/pages/FirstPage.qml \
    rpm/harbour-metacrane.spec \
    rpm/harbour-metacrane.yaml \
    harbour-metacrane.desktop \
    qml/pages/AboutPage.qml \
    qml/pages/CranePage.qml \
    qml/MessageDialog.qml \
    qml/pages/MessageDialog.qml \
    qml/pages/ViewText.qml \
    qml/pages/UploadTextPage.qml \
    qml/pages/UploadFilePage.qml

HEADERS += \
    3rdparty/QtWebsocket/QWsSocket.h \
    3rdparty/QtWebsocket/QWsServer.h \
    3rdparty/QtWebsocket/QWsHandshake.h \
    3rdparty/QtWebsocket/QWsFrame.h \
    3rdparty/QtWebsocket/QTlsServer.h \
    3rdparty/QtWebsocket/functions.h \
    3rdparty/QtWebsocket/WsEnums.h \
    src/metacraneclient.h \
    src/metacranesocket.h \
    src/filesearch.h

INCLUDEPATH += 3rdparty
