import QtQuick 2.0
import Sailfish.Silica 1.0
import MetacraneClient 1.0
import FileSearch 1.0

Page {
    property string crane_name: "Unknown"
    id: page

    FileSearch {
        id: fileSearch
    }

    SilicaListView {
        id: listView
        anchors.fill: parent

        header: Component { Column {
            id: column
            spacing: Theme.paddingSmall
            PageHeader {
                title: "Upload File | "+crane_name
            }
            /*Label {
                id: pathLabel
                font.pixelSize: Theme.fontSizeSmall
                text: fileSearch.searchPath
            }*/
            SearchField {
                id: searchField
                focus: true
                text: ""
                placeholderText: "Filter"
                width: page.width
                height: Theme.itemSizeLarge
                //EnterKey.enabled: true
                //EnterKey.iconSource: "image://theme/icon-m-enter-accept"
                EnterKey.onClicked: {
                    fileSearch.search(text)
                    searchField.focus = false
                }
                onTextChanged: {
                    // Can't use this because modified model steals focus
                    // from keyboard
                    //fileSearch.search(text)
                    if(text === "")
                        fileSearch.search("")
                }
            }
        }}
        footer: Component { Column {
            id: column
            spacing: Theme.paddingSmall
            Label {
                id: pathLabel
                x: Theme.paddingLarge
                font.pixelSize: Theme.fontSizeSmall
                text: fileSearch.searchPath
                color: Theme.secondaryColor
            }
        }}

        model: fileSearch.result
        delegate: ListItem {
            id: delegate
            //height: Theme.itemSizeSmall + Theme.paddingMedium * 2
            height: Theme.itemSizeSmall

            Label {
                id: mainLabel
                x: Theme.fontSizeSmall*2.5 + Theme.paddingLarge
                //width: listView.contentWidth
                width: page.width - Theme.paddingLarge * 2 - Theme.fontSizeSmall*2.5
                text: modelData.name
                anchors.verticalCenter: parent.verticalCenter
                color: delegate.highlighted ? Theme.highlightColor : Theme.primaryColor
                wrapMode: Text.Wrap
                font.underline: modelData.type === "file"
            }
            Label {
                anchors.bottom: parent.bottom
                anchors.left: parent.left
                anchors.margins: Theme.paddingLarge
                font.pixelSize: Theme.fontSizeSmall
                color: Theme.secondaryColor
                text: modelData.type == "file" ? "File" :
                        modelData.type == "dir" ? "Dir" :
                        modelData.type
            }
            onClicked: {
                console.log("Clicked "+index+": "+modelData.path)
                if(modelData.type == "dir"){
                    fileSearch.searchPath = modelData.path
                    searchField.text = ""
                    return
                }
                MetacraneClient.uploadFile(modelData.path)
                pageStack.pop()
            }
        }
        VerticalScrollDecorator {}
    }
}
