#include "filesearch.h"
#include <QDebug>
#include <QDir>

FileSearch::FileSearch(QObject *parent) :
    QObject(parent),
    m_search_path(QDir::homePath())
{
    search();
}

void FileSearch::setSearchPath(QString searchPath)
{
    qDebug()<<"setSearchPath"<<searchPath;
    // TODO: Normalize
    QFileInfo info(searchPath);
    m_search_path = info.absoluteFilePath();
    searchPathChanged();
    search();
}

void FileSearch::search()
{
    m_result.clear();

    QStringList searchlist;
    //searchlist.append(QString("*")+m_search_string+"*");
    QString s = m_search_string;
    s.replace(" ", "*");
    searchlist.append(QString("*")+s+"*");

    QDir dir(m_search_path);
    //dir.setSorting(QDir::Time | QDir::Reversed);
    dir.setSorting(QDir::Name);
    QStringList filenames = dir.entryList(searchlist);
    for(QString &filename : filenames){
        if(filename == ".")
            continue;
        QString path = m_search_path+"/"+filename;
        QString type = "file";
        QFileInfo info(path);
        if(info.isDir())
            type = "dir";
        ResultFile *r = new ResultFile(path, filename, type);
        if(filename == "..")
            m_result.prepend(r);
        else
            m_result.append(r);
    }
    resultChanged();
    qDebug()<<"number of results:"<<m_result.size();
}

void FileSearch::search(QString text)
{
    qDebug()<<"search:"<<text;
    m_search_string = text;
    search();
}
