#ifdef QT_QML_DEBUG
#include <QtQuick>
#endif
#include <sailfishapp.h>
#include <QGuiApplication>
#include <QQuickView>
#include <QtQml/QQmlEngine>
#include <QtQml/QJSEngine>
#include <QtQml/qqml.h>
#include "metacraneclient.h"
#include "filesearch.h"

QGuiApplication *app = NULL;
QQmlContext *context = NULL;
MetacraneClient *mc_client = NULL;
static QObject* mc_client_provider(QQmlEngine *engine, QJSEngine *scriptEngine)
{
    (void)engine; (void)scriptEngine;
    if(!mc_client)
        mc_client = new MetacraneClient(app);
    return mc_client;
}

int main(int argc, char *argv[])
{
    app = SailfishApp::application(argc, argv);
    QQuickView *view = SailfishApp::createView();
    context = view->rootContext();

    qmlRegisterSingletonType<MetacraneClient>("MetacraneClient", 1, 0,
            "MetacraneClient", &mc_client_provider);

    qmlRegisterType<FileSearch>("FileSearch", 1, 0, "FileSearch");

    view->setSource(SailfishApp::pathTo("qml/harbour-metacrane.qml"));
    view->show();
    return app->exec();
}

